package com.tema1.players;

import com.tema1.decks.Hand;
import com.tema1.decks.Sack;
import com.tema1.decks.Stall;

import java.util.List;

import static com.tema1.common.Constants.STARTING_GOLD;

/**
 * Class which describes a player.
 */
public abstract class Player {
    Hand hand;
    Sack sack;
    private Stall stall;
    int gold;
    int position;
    private int finalScore = 0;

    public Player(final int position) {
        gold = STARTING_GOLD;
        stall = new Stall();
        this.position = position;
    }

    /**
     * @param list generated by GameDeck every subround.
     */
    public final void setHand(final List<Integer> list) {
        hand = new Hand(list);
    }

    /**
     * Function which generates the coresponding sack for a strategy.
     * @param round Used in the greedy strategy.
     * @return the generated Sack.
     */
    public abstract Sack getSack(int round);

    /**
     * Adds the sack to the stall.
     * @param checked If true, adds only the declared good.
     */
    public final void addSackToStall(final boolean checked) {
        stall.addSack(sack, checked);
    }

    public final void changeGold(final int amount) {
        gold += amount;
    }

    /**
     * Function which generates the Sheriff decision.
     */
    public abstract SheriffDecision getDecision(int bribe, int playerPos, int noPlayers);

    /**
     * @return list containing the order in which the players are checkd.
     */
    public abstract List<Integer> getOrder(int noPlayers);

    public final void addBonus() {
        stall.addBonus();
    }

    public final int getBaseScore() {
        return stall.getScore() + gold;
    }

    public final int[] getStall() {
        return stall.getLegalAmount();
    }

    public final void setFinalScore(final int score) {
        finalScore = score;
    }

    public final int getFinalScore() {
        return finalScore;
    }

    abstract String getPlayerType();

    public final void printScore() {
        System.out.println(position + " " + getPlayerType() + " " + finalScore);
    }
}
